var zjhm = '';
var initpage;
var sbqDate = '';
var yearBblxDm = ['10414', '10420'];
var token = "";
var yhsSyxx = {};
$(function () {
  showLoading();
  getInitTable();
})

function getInitTable() {
  token = getUrlParam("token");
  $.ajax({
    type: "post",
    url: config.url + "/online/easy/declare_ccxws_lb",
    dataType: "json", // 请求方式为jsonp
    // async: false,
    data: {
      djxh: getUrlParam("djxh"),
      token: getUrlParam("token"),
      sbq: "",
      pzzlDm: getUrlParam("pzzlDm"),
      value: getUrlParam("value")
    },
    // beforeSend:function(){
    //   myAlert("提示", "正在获取初始化信息", "确定")
    // },
    success: function (data) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数
      hideLoading();
      var companyInfo = data;
      if (companyInfo.returnCode == '00') {
        config.value = companyInfo.content.value
        companyInfo.content.config = config
        companyInfo.content.return = true; /* @Author ygy @Date 10:12 2020/7/8 @Description 前端判断接口成功返回数据标记用于区分是否执行初始化table方法*/
        config.return = true;
        if (companyInfo.content.yhsSyxx != undefined && companyInfo.content.yhsSyxx != null && JSON.stringify(companyInfo.content.yhsSyxx) != '{}') {
          yhsSyxx = companyInfo.content.yhsSyxx;
        } else {
          yhsSyxx = {};
        }
        initpage = initPage(companyInfo.content);
      } else {
        hideLoading();
        if (data.returnMessage != undefined) {
          alertWarning(data.returnMessage);
        } else {
          alertWarning(data.returnMessage);
        }
        if (!companyInfo.content) {
          companyInfo.content = {};
          companyInfo.content.djxh = getUrlParam("djxh");
          companyInfo.content.return = false;
        }
        companyInfo.content.config = config
        initpage = initPage(companyInfo.content);
        // 弹出错误对话框
      }
      $("#getInputValue").on("focus", function () {
        WdatePicker({
          isShowClear: false,
          dateFmt: 'yyyy-MM',
          onpicking: function (dp) {

            initpage.changeDate(this, dp);
          }
        });
      });
    },
    error: function (xhr) {
      hideLoading();
      //jsonp 方式此方法不被触发
      console.log("=======error======================")
    }
  })
}
/**
 * 按期申报填报列表页控制脚本
 *
 * @author 于广洋
 * @modify 王雷
 */
// -------------------------------
/**
 * 绘制税种填报页面
 *
 * @param {*} companyInfo
 */
function initPage(companyInfo) {
  getIEVersion();
  localStorage.setItem("cancellation", null);
  var companyInfo = companyInfo;
  var djxh = companyInfo.djxh;
  var nowdate = ""; // 存储当前选择的时间框;
  var submitData
  /**
   * 展示税种申报信息
   */
  var showTax = function (taxInfo) {
    if (taxInfo.length > 0) {
      for (var i = 0; i < taxInfo.length; i++) {
        if (taxInfo[i].sbrq) {
          taxInfo[i].sbrq = tool.formatDate(taxInfo[i].sbrq.split(" ")[0]);
        }
        if (taxInfo[i].bblxDm == '30101') {
          taxInfo[i].sssqQ = "-";
          taxInfo[i].sssqZ = "-";
        }
        if (taxInfo[i].sbzt == 'Y') {
          taxInfo[i].sbztText = "已申报";
        }
        if (taxInfo[i].sbzt == 'N') {
          taxInfo[i].sbztText = "未申报";
        }
      }
    }
    var id = "#taxGrid";
    var buttonHtml = "采集并申报";
    var order = ["pzzlMc", "djxh", "sssqQ", "sssqZ", "sbztText", "do"];
    var promptStatement = "";
    var headerList = [{
      name: "序号",
      width: "5%"
    }, {
      name: "申报表",
      width: "40%"
    }, {
      name: "登记序号",
      width: "15%"
    }, {
      name: "税款所属期起",
      width: "10%"
    }, {
      name: "税款所属期止",
      width: "10%"
    }, {
      name: "申报状态",
      width: "10%"
    }, {
      name: "操作",
      width: "10%"
    }];
    //渲染表
    getTableDeclaration(id, order, headerList, taxInfo, buttonHtml, promptStatement)
  };
  /**
   * 税务申报table渲染
   * @param {*} id
   * @param {*} order
   * @param {*} headerList
   * @param {*} ddt
   * @param {*} buttonHtml
   */
  var getTableDeclaration = function (id, order, headerList, ddt, buttonHtml, promptStatement) {
    var tableObj = {
      id: id, //tabel父元素的id
      autoHeight: ddt.length > 0 ? 10 : "",
      containerWidth: "99%", //table占父元素的百分比
      autoHeight: ddt.length > 0 ? 10 : "", // 默认10行
      order: order, //数据按照什么顺序排序  1.do为是否保函操作 2.序号列会自动添加不需要写
      onlyId: "uuId", //数据的唯一标识
      height: "320", //表格的高度
      buttonHeight: "", //表格的高度
      buttonHtml: buttonHtml, //按钮里的字
      headerList: headerList, //表头名字及占比，顺序与order对应
      promptStatement: promptStatement, // 没有数据时默认提示
      data: {
        page: "1",
        pageSize: ddt.length
      },
      jsonReady: ddt,
      callback: function (data, node) {
        data.operateType = '3';
        data.sbbz = '3';
        data.value = config.value;
        if (data.sbzt == "Y") {
          myAlert("提示", "当前印花税已经申报", "确定")
          return false;
        }
        if (data.sourceFlag == "ssfwpt_sbzj") {
          window.mlistener = {
            selectRowData: {},
            urlList: {}
          };
          var openCollectYHS = {
            "nsrsbh": data.nsrsbh,
            "djxh": data.djxh,
            "skssqq": data.sssqQ,
            "skssqz": data.sssqZ,
            "lybz": "online",
            "gzbz": "0",
            "syuuid": "",
            "nsrmc": data.nsrmc,
            "ssdabh": "",
            "nsrsbq": data.nsrsbq,
            "token": data.token,
            "rylx": "",
            "zjlx": "",
            "zjhm": "",
            "dlDjxh": "",
            "nsqxDm": data.nsqxDm,
            "zsDjxh": data.zsDjxh,
            "stateType": "add",
            "sycjType": "yhs",
            "sourceFlag":"kjsb"
          }
          if (JSON.stringify(yhsSyxx) != '{}') {
            openCollectYHS.stateType = "edit";
            openCollectYHS.gzbz = '1';
            openCollectYHS.syuuid = yhsSyxx.syuuid;
          } else {
            openCollectYHS.stateType = "add";
            openCollectYHS.gzbz = '0';
            openCollectYHS.syuuid = "";
          }
          var url = "property_tax_plugin";
          if (config.environmental == 'test') {
            url = "property_tax_plugin";
          } else {
            url = "online_property_tax_plugin";
          }
          var urlList = {
            openTable: "/" + url + "/yhs/openTable",
            saveSbbInfo: "/" + url + "/yhs/saveSbbInfo "
          }
          window.mlistener.selectRowData = openCollectYHS;
          window.mlistener.urlList = urlList;
          window.open(config.collectPage, '_blank');
          Object.defineProperty(mlistener, 'returnSelectRowData', {
            set: function (val) {
              setTimeout(function () {
                getTaxDeclaration(sbqDate, 'N');
              }, 1000);
            }
          })
        } else {
          data.djxh = companyInfo.djxh;
          data.iszzsybjc = companyInfo.iszzsybjc; // 一表申报代码
          data.nsrsbh = companyInfo.nsrsbh; // 那随人识别号
          data.nssbq = nowdate;
          data.checkTime = false;
          if (data.pzzlDm === '11602') {
            var List = companyInfo.taxInfos.filter(function (item) {
              return item.pzzlDm == '10101' || item.pzzlDm == '10102'
            })
            if (List.length === 0) {
              data.checkTime = true;
            }
            for (var i = 0; i < List.length; i++) {
              if (List[i].sssqQ !== data.sssqQ || List[i].sssqZ !== data.sssqZ) {
                data.checkTime = true;
                break;
              }
            }
          }
          submitData = data;
          if (node.context.innerText == "填写申报表" && companyInfo.iszzsybjc == "01" && data.pzzlDm == "10101") {
            // if(node.context.innerText=="填写申报表"){
            initpage.declarationMethod('N')
            //                    $('#myMask').show();
            //                    $('#myModal').show();
            //                    $('#dName').html(data.pzzlMc);
            //                    $('#dName').attr("title",data.pzzlMc);//修改title值
            //                    $('#ybName').html(data.pzzlMc);
            //                    $('#ybName').attr("title",data.pzzlMc);//修改title值
          } else {
            declarationMethod("N")
          }
        }
      } //点击按钮后的回调函数
    };
    var object = tool.tableCreate(tableObj);
    //        object.jsonReadyTo(ddt, { page: "1", pageSize: ddt.length });
  };

  /**
   * 税务申报 初始化数据获取
   * @param {*} mydate
   */
  //地址
  //http://sbjs.tjsat.gov.cn:18090
  //http://localhost:7070
  var url;
  if (companyInfo) {
    url = companyInfo.config.url;
  }
  var getTaxDeclaration = function (date,type) {
    // TODO 开始加载等待动画
    showLoading();
    var param = {
      djxh: djxh,
      token: "",
      sbq: date,
      pzzlDm: companyInfo.pzzlDm,
      value: config.value
    }
    $.ajax({
      url: url + "/online/easy/get_declare_ccxws_lb",
      data: param,
      type: "POST",
      dataType: "JSON",
      // beforeSend:function(){
      //   myAlert("提示", "正在获取初始化信息", "确定")
      // },
    }).done(function (data) {
      hideLoading();
      if (data.returnCode) {
        if (data.returnCode != '00') {
          myAlert("提示", data.returnMessage, "确定")
          return
        }
        drawGrid(data.content);
        companyInfo = data.content;
        if (companyInfo.yhsSyxx != undefined && companyInfo.yhsSyxx != null && JSON.stringify(companyInfo.yhsSyxx) != '{}') {
          yhsSyxx = companyInfo.yhsSyxx;
        } else {
          yhsSyxx = {};
        }
        zjhm = companyInfo.zjhm
        config.value = companyInfo.value;
        if (type == 'Y') {
          myAlert("提示", "重置清册成功", "确定")
        }
      } else {
        if (data.returnMessage != undefined) {
          alertWarning(data.returnMessage);
        } else {
          alertWarning(data.returnMessage);
        }
      }
    }).always(function (data) {
      hideLoading();
    });
  };
  var resetInventory = function (date) {
    // TODO 开始加载等待动画
    showLoading();
    console.log('companyInfo', companyInfo);
    var param = {
      djxh: djxh,
      operateType: companyInfo.operateType,
      sbsq: companyInfo.sbsq,
      isFresh: true,
      pzzlDm: "",
      refreshSbzt: '1',
    }
    $.ajax({
      url: "/online/declare/getPzzlList",
      data: param,
      type: "POST",
      dataType: "JSON",
      // beforeSend:function(){
      //   myAlert("提示", "正在获取初始化信息", "确定")
      // },
    }).done(function (data) {
      hideLoading();
      if (!data.success) {
        myAlert("提示", data.returnMessage, "确定")
        return
      }
      getTaxDeclaration(date, 'Y')
    }).always(function (data) {
      hideLoading();
    });
  };
  /**
   * 隐藏modal
   */
  var closeModal = function () {
    $('#ybName').html("");
    $('#dName').html("");
    $('#myMask').hide();
    $('#myModal').hide();
  }

  var drawGrid = function (bean) {
    //两个表合成一个表
    $.each(bean.financialInfos, function (i, item) {
      bean.taxInfos.push(item);
    });
    if (bean.taxInfos.length == 0) {
      showTax(bean.taxInfos);
      alertInfo("印花税快捷申报暂无数据!");
    } else {
      showTax(bean.taxInfos);
    }
  };

  /**
   * 日期改变时触发
   * N 非强制刷新
   * @param {*} obj
   * @param {*} dp
   */
  var changeDate = function (obj, dp) {
    date = dp.cal.getNewDateStr();
    nowdate = date; // 给缓存时间赋值
    // 加了一个延时，时间改变后时间框没有收起隐藏就加载数据，没有找到好的解决办法，暂时用延时处理
    sbqDate = date
    setTimeout(function () {
      getTaxDeclaration(date, 'N');
    }, 50);
  };

  var refresh = function () {
    myConfirm("消息", "您确定需要重置申报清册吗？点击确定继续", "确定", "取消", function () {
      resetInventory(nowdate, "Y");
    });
  };
  //申报方式 当iszzsybjc=01同时pzzlDm=010101时，调用改方法
  var declarationMethod = function (statu) {
    submitData.ybjcState = statu;
    submitData.value = config.value;
    //需要判断在线还是税表的开关
    if (submitData.sourceFlag == "ssfwpt_sbzj") {
      window.mlistener = {
        selectRowData: {},
      };
      submitData.fillingFlag = "normal" // 填报标记
      submitData.saveUserId = "zxtb"; // 用户id
      submitData.zjhm = zjhm
      window.mlistener.selectRowData = submitData;
      if (yearBblxDm.indexOf(data.bblxDm) == -1) {
        window.open(config.ssfwptPage, '_blank');
      } else {
        data.saveUserId = "zxtb_singleReport"; // 用户id
        data.userId = "zxtb"; // userId
        window.open(config.yearTaxTable, '_blank');
      }
      Object.defineProperty(mlistener, 'returnSelectRowData', {
        set: function (val) {
          setTimeout(function () {
            getTaxDeclaration(sbqDate, 'N');
          }, 1000);
        }
      })
    } else {
      //"ssfwpt_zxtb"
      // var form = $("#changeForm");
      // form.find("#changeForm_data").val(JSON.stringify(submitData));
      // form.submit();
      // showLoading()
      var falg = "declare";
      window.taxInfo = JSON.stringify(submitData);
      localStorage.setItem("data", JSON.stringify(submitData));
      // if (data.url == "edit.jsp") {
      submitData.flag = true;
      submitData.encryptKey = config.value;
      var url = config.spreadUrl + "/online_report/declare/toPzzl?falg=" + falg
      var form = $("#changeForm");
      form.attr('action', url); //通过jquery为action属性赋值
      form.find("#changeForm_data").val(JSON.stringify(submitData));
      form.submit();
      return false;
      // $.ajax({
      //   type: "POST",
      //   url: url + "/online/declare/toPzzl",
      //   dataType: "json", // 请求方式为jsonp
      //   data: {
      //     data: JSON.stringify(submitData)
      //   },
      //   success: function (data) {
      //     hideLoading()
      //     if (data.code == 99 || data.code == "99") {
      //       if (data.errmsg != undefined) {
      //         alertWarning(data.errmsg);
      //       } else {
      //         alertWarning(data.returnMessage);
      //       }
      //       return false
      //     }
      //     window.taxInfo = JSON.stringify(submitData);
      //     localStorage.setItem("data", JSON.stringify(submitData));
      //     // if (data.url == "edit.jsp") {
      //     submitData.flag = true;
      //     submitData.encryptKey = config.value;
      //     var url = config.spreadUrl + "/online_report/declare/toPzzl?falg=" + falg
      //     var form = $("#changeForm");
      //     form.attr('action', url); //通过jquery为action属性赋值
      //     form.find("#changeForm_data").val(JSON.stringify(submitData));
      //     form.submit();

      //     // window.open(config.spreadUrl+"/online_report/declare/toPzzl?falg=" + falg + '&data=' + JSON.stringify(submitData));
      //     // window.open(config.webUrl + "declare/edit.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
      //     // }
      //     /*  else if (data.url == "yearReport.jsp") {
      //                              window.open(config.webUrl + "declare/yearReport.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
      //                            } else if (data.url == "yearReportGLB.jsp") {
      //                              window.open(config.webUrl + "declare/yearReportGLB.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
      //                            } else {
      //                              //因为后台不知道返回路径是什么样的就直接改成了else data.url == "error.jsp"
      //                              window.open(config.webUrl + "error/index.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
      //               }*/
      //   },
      //   error: function (xhr) {
      //     //jsonp 方式此方法不被触发
      //     if (data.returnMessage == undefined) {
      //       if (data.returnMessage == undefined) {
      //         alertWarning(data.errmsg);
      //       } else {
      //         alertWarning("程序错误，请联系管理员！");
      //       }
      //     } else {
      //       alertWarning(data.returnMessage);
      //     }
      //     hideLoading()
      //     console.log("=======error======================")
      //   }
      // })

      // closeModal();
    }
  }
  /**
   * 重置调用方法
   * @param {} params
   */
  $("#reset,#reset1").on("click", refresh);
  $("#goRecord").click(function () {
    //TODO 调用备案接口
  });
  // 格式化后台返回的时间
  if (companyInfo.config.return) {
    $("#getInputValue").val(tool.formatDate(companyInfo.sbsq));
    nowdate = companyInfo.sbsq;
    drawGrid(companyInfo);
  }
  //页面出现滚动条，监听滚动条变化将高赋值给模态框
  window.onscroll = function () {
    $("#myModal").css("top", $(document).scrollTop() + 235);
  }
  return {
    changeDate: changeDate,
    reset: reset,
    declarationMethod: declarationMethod,
    closeModal: closeModal
  }
}